/*

 Copyright (c) [2023] [pcm]
 [pcm-coordinator] is licensed under Mulan PSL v2.
 You can use this software according to the terms and conditions of the Mulan PSL v2.
 You may obtain a copy of Mulan PSL v2 at:
          http://license.coscl.org.cn/MulanPSL2
 THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 EITHER EXPaRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 See the Mulan PSL v2 for more details.

*/

package core

import (
	"context"
	"github.com/zeromicro/go-zero/core/logx"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/models"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
)

type ListRegionLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewListRegionLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ListRegionLogic {
	return &ListRegionLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ListRegionLogic) ListRegion() (resp *types.ListRegionResp, err error) {
	// todo: add your logic here and delete this line
	var regionSlurmArray []models.RegionSlurm
	var regions []types.Region
	var jobCount int64
	var regionResult []types.Region
	l.svcCtx.DbEngin.Find(&regionSlurmArray)
	utils.Convert(regionSlurmArray, &regions)
	// 查询超算上的job todo
	for _, region := range regions {
		if region.RegionName == "Changsha HPC Center" {
			l.svcCtx.DbEngin.Raw("select count(*) from task t join hpc h on t.id = h.task_id and t.status != 'Completed' and h.service_name = 'th'").Scan(&jobCount)
			region.RunningJobs = jobCount
		}
		if region.RegionName == "Zhijiang HPC Center" {
			l.svcCtx.DbEngin.Raw("select count(*) from task t join hpc h on t.id = h.task_id and t.status != 'Completed' and h.service_name = 'ac'").Scan(&jobCount)
			region.RunningJobs = jobCount
		}
		regionResult = append(regionResult, region)

	}

	resp = &types.ListRegionResp{
		Code: 200,
		Msg:  "Success",
		Data: regionResult,
	}
	return
}
